src/medux/preferences/urls.py
app_name = "preferences"

urlpatterns = [
]

src/medux/preferences/models.py
#  MedUX - Open Source Electronical Medical Record
#  Copyright (c) 2022  Christian González
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Affero General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Affero General Public License for more details.
#
#  You should have received a copy of the GNU Affero General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
import warnings

from django.conf import settings
from django.contrib.auth.models import Group
from django.core.exceptions import ValidationError, ImproperlyConfigured
from django.db import models
from django.utils.translation import gettext_lazy as _

from medux.common.models import Tenant
from medux.preferences.definitions import Scope, KeyType, ScopeIcons
from medux.preferences.registry import PreferencesRegistry


def validate_lower(value):
    if not value == value.lower():
        raise ValidationError("%(value)s must be lowercase.", params={"value": value})


class BasePreference(models.Model):
    """Basic model which holds namespace and key of a setting.
    ScopedPreference use this model as FK, to prevent redundant storage of preferences.
    """

    class Meta:
        verbose_name = verbose_name_plural = _("Preferences")
        ordering = ["namespace", "key"]

    namespace = models.CharField(max_length=25, validators=[validate_lower])
    key = models.CharField(max_length=255, validators=[validate_lower])

    def save(self, **kwargs):
        self.clean()
        super().save(**kwargs)

    def clean(self):
        """Make sure namespace and key are lowercase."""
        self.namespace = str(self.namespace).lower()
        self.key = str(self.key).lower()

    @classmethod
    def namespaces(cls) -> list[str]:
        """:return: a list of available namespaces."""
        # FIXME this is highly insufficient. distinct() would be better,
        #       but not available on SQLite/dev
        result = set()
        for s in cls.objects.order_by("namespace").values_list("namespace", flat=True):
            result.add(s)
        return list(result)

    @classmethod
    def keys(cls) -> list[tuple[str, str]]:
        """:return: a tuple[namespace,key] of all currently available keys."""

        return list(set((item.namespace, item.key) for item in cls.objects.all()))

    @property
    def icon(self):
        """:return: the preferences' icon name."""
        return PreferencesRegistry.icon(self.namespace, self.key)

    @property
    def key_type(self) -> KeyType:
        """:return: the setting's key type.

        This is a convenience method and gets it from the PreferencesRegistry."""
        return PreferencesRegistry.key_type(self.namespace, self.key)

    @property
    def help_text(self) -> str:
        """:return: the setting's help_text.
        This is a convenience method and gets it from the PreferencesRegistry."""
        return PreferencesRegistry.help_text(self.namespace, self.key)

    def __str__(self):
        return f"{self.namespace}.{self.key}"


class ScopedPreferenceManager(models.Manager):
    """A manager that allows easily creating ScopedPreferences with their
    BasePreference namespace/key attributes directly:

    ScopedPreference.objects.create(namespace="foo", key="bar", scope=...)

    The manager tries to find a Basepreference with that namespace/key and links to it.
    If none found, it is created.
    """

    def create(self, **kwargs):
        if "namespace" in kwargs and "key" in kwargs:
            if "base" in kwargs:
                # base AND namespace/key given...
                warnings.warn(
                    message="'base' and 'namespace'/'key' for "
                    "ScopedPreference creation given. "
                    "Ignoring 'namespace'/'key', just taking 'base'."
                )
                del kwargs["namespace"]
                del kwargs["key"]
            else:
                namespace = kwargs.pop("namespace")
                key = kwargs.pop("key")
                try:
                    kwargs["base"] = BasePreference.objects.get(
                        namespace=namespace, key=key
                    )
                except BasePreference.DoesNotExist:
                    kwargs["base"] = BasePreference.objects.create(
                        namespace=namespace, key=key
                    )

        return super().create(**kwargs)


class ScopedPreference(models.Model):
    """Model class for all scoped MedUX preferences.

    Preferences are generally saved as strings, but are interpreted at retrieval
    and cast into their correct types. ScopedPreference knows about
    ``str``, ``int``, ``bool``

    You can easily access preferences using
        ScopedPreference.get(namespace, key, scope, ...)
    """

    class Meta:
        verbose_name = verbose_name_plural = _("Scoped preferences")
        ordering = ["base__namespace", "base__key", "scope"]
        unique_together = [
            ["base", "scope", "tenant"],
            ["base", "scope", "group"],
            # TODO: ["base", "scope", "device"],
            ["base", "scope", "user"],
        ]
        permissions = [
            (
                "change_own_user_scopedpreference",
                _("Can change own user's preferences"),
            ),
            (
                "change_own_tenant_scopedpreference",
                _("Can change own tenant's preferences"),
            ),
            (
                "change_own_group_scopedpreference",
                _("Can change own groups' preferences"),
            ),
            ("change_device_scopedpreference", _("Can change a device's preferences")),
        ]

    objects = ScopedPreferenceManager()

    base = models.ForeignKey(
        BasePreference, on_delete=models.CASCADE, related_name="scopedpreferences"
    )
    """The FK to the basic preferences fields like namespace, key."""

    tenant = models.ForeignKey(
        Tenant,
        verbose_name=_("Tenant"),
        on_delete=models.CASCADE,
        default=None,
        null=True,
        blank=True,
    )
    group = models.ForeignKey(
        Group, on_delete=models.CASCADE, default=None, null=True, blank=True
    )
    # device = models.ForeignKey(
    #     "Device", on_delete=models.CASCADE, default=None, null=True, blank=True
    # )
    user = models.ForeignKey(
        settings.AUTH_USER_MODEL,
        on_delete=models.CASCADE,
        default=None,
        null=True,
        blank=True,
    )

    scope = models.IntegerField(choices=Scope.choices)
    """The scope where this setting is valid."""

    value = models.CharField(max_length=255, null=True)
    """The value of the setting. NULL means the setting using this scope
    was deleted, and the next matching scope is used."""

    @property
    def namespace(self) -> str:
        """:return: The preferences' namespace"""
        return self.base.namespace

    @property
    def key(self) -> str:
        """:return: The preferences' key"""
        return self.base.key

    @property
    def icon(self) -> str:
        """:return: the preferences' icon name."""
        return self.base.icon

    @property
    def key_type(self) -> KeyType:
        """:return: the preference's key type.

        This is a convenience method and gets it from the base preference."""
        return self.base.key_type

    @property
    def help_text(self) -> str:
        return self.base.help_text

    def clean(self):
        """Check if object FK is present if scope demands it."""

        # Make value a str
        if self.value is None:
            self.value = ""
        self.value = self.value.strip()
        # Scopes with their correct object FK
        if self.scope == Scope.USER:
            if not self.user:
                raise ValidationError(_("If scope is 'user', a user must be provided"))
        elif self.scope == Scope.DEVICE:
            if not self.device:
                raise ValidationError(
                    _("If scope is 'device', a device must be provided")
                )
        elif self.scope == Scope.GROUP:
            if not self.group:
                raise ValidationError(
                    _("If scope is 'group', a group must be provided")
                )
        elif self.scope == Scope.TENANT:
            if not self.tenant:
                raise ValidationError(
                    _("If scope is 'tenant', a tenant must be provided")
                )
        # TODO check if user/device/group is filled in if scope is one of them

    @classmethod
    def keys(cls) -> list[tuple[str, str]]:
        """:return: a Tuple[namespace,key] of all currently available keys."""

        return BasePreference.keys()

    @classmethod
    def namespaces(cls) -> list[str]:
        """:return: a list of available namespaces."""
        return BasePreference.namespaces()

    def __str__(self) -> str:
        # add user, tenant, group
        fk = ""
        if self.scope == Scope.USER:
            fk = f": '{self.user}'"
        elif self.scope == Scope.GROUP:
            fk = f": '{self.group}'"
        elif self.scope == Scope.TENANT:
            fk = f": '{self.tenant}'"
        a = ".".join([self.base.namespace, self.base.key])
        return f"{a} [{Scope(self.scope).name}{fk}]: {self.value}"

    @classmethod
    def assure_exists(cls, namespace, key, scope) -> None:
        """Raises KeyError if given preferences are not registered."""
        if not PreferencesRegistry.exists(namespace, key, scope):
            raise KeyError(

src/medux/preferences/templates/preferences/components/preferences_item.html
{% load i18n %}

<div id="preferences-item-{{ namespace }}-{{ key }}">
  <div class="card mb-2 preferences-item">
    <div class="row g-0">

      <div class="col-1 bg-light text-center g-0 preferences-item-scope-tabs">
        {# tablist for Scopes #}
        <div class="nav nav-tabs flex-column" id="{{ item.namespace }}-{{ item.key }}-tab" role="tablist" aria-orientation="vertical">
          {% for item in items %}
            <button class="nav-link position-relative{% if forloop.first %} active{% endif %}  "
                    id="{{ item.namespace }}-{{ item.key }}-{{ item.get_scope_display }}-tab"
                    aria-current="{% if forloop.first %}true{% else %}false{% endif %}"
                    aria-selected="{% if forloop.first %}true{% else %}false{% endif %}"
                    aria-controls="{{ item.namespace }}-{{ item.key }}-{{ item.get_scope_display }}"
                    role="tab"
                    data-bs-toggle="tab"
                    data-bs-target="#{{ item.namespace }}-{{ item.key }}-{{ item.get_scope_display }}"
            >
              <i class="bi bi-{{ item.get_scope_icon }} fs-6" title="{{ item.get_scope_display }}"></i>
              {% if not item.effective %}<s>{% endif %}<small class="d-none d-lg-block">{{ item.get_scope_display }}</small>{% if not item.effective %}</s>{% endif %}
              {% if item.effective %}
                {% with item.get_scope_display as scope %}
                  <i class="bi bi-patch-check position-absolute text-dark fs-3 translate-middle top-50 start-0"
                     title="{% blocktranslate %}{{ scope }} provides the effective setting.{% endblocktranslate %}"
                  >
                {% endwith %}
{#                <span class="visually-hidden">{% translate 'This is the effective setting.' %}</span>#}
              </i>
              {% endif %}
            </button>

          {% endfor %}
        </div>
      </div>

      <div class="col-11 tab-content">
        {% for item in items %}
          <div class="card-body position-relative tab-pane{% if forloop.first %} show active{% endif %}"
               id="{{ item.namespace }}-{{ item.key }}-{{ item.get_scope_display }}"
               aria-labelledby="{{ item.namespace }}-{{ item.key }}-{{ item.get_scope_display }}-tab"
               role="tabpanel"
               tabindex="0"
          >
            <div class="row">
              <div class="col-10 col-lg-11 position-relative">
                <h5 class="card-title">
                  {% if items.0.icon %}
                    <i class="preferences-icon bi bi-{{ items.0.icon }}"></i>
                  {% endif %}
                  {{ item.key }}
                </h5>
                {#                      <h6 class="card-subtitle mb-2 text-muted"></h6>#}
                <p class="card-text">
                  <span class="text-muted">{{ item.help_text }}</span>
                  {% if item.key_type == "text" %}
                    <textarea class="form-control"{% if item.scope == 1 %} disabled{% endif %} id="key-{{ item.namespace }}-{{ item.key }}-{{ item.scope }}-input" >{{ item.value }}</textarea>
                  {% elif item.key_type == "str" %}
                    <input
                        class="form-control"
                        type="text"
                        id="key-{{ item.namespace }}-{{ item.key }}-{{ item.scope }}-input"
                        value="{{ item.value }}"
                        {% if item.scope == 1 %}readonly{% endif %}
                    >
                  {% endif %}
                </p>
                <div >
                  {# display buttons for VENDOR #}
                  {% if item.scope == 1 or not item.id %}
                    <span class="d-inline-block"
                          tabindex="0"
                          data-bs-toggle="tooltip"
                        {% if item.scope == 1 %}
                          title="{% translate 'Vendor preferences cannot be changed.' %}"
                        {% elif not item.id %}
                          title="{% translate 'This preference is not saved yet.' %}"
                        {% endif %}
                    >
                  {% endif %}


                  {% if item.scope == 1 or not item.id %}
                    </span>
                  {% endif %}
                </div>
              </div>

              {% if item.key_type == "int" %}
                <div class="col-2 col-lg-1 border-start">
                  <div class="form-control"{% if item.scope == 1 %} disabled{% endif %}>
                    <input type="number" id="key-{{ item.namespace }}-{{ item.key }}-{{ item.scope }}-input">
                  </div>
                </div>
              {% elif item.key_type == "bool" %}
                <div class="col-1 border-start">
                  <div class="form-check form-switch fs-2"{% if item.scope == 1 %} disabled{% endif %}>
                    <input class="form-check-input"
                           type="checkbox"
                           role="switch"
                           id="key-{{ item.namespace }}-{{ item.key }}-{{ item.scope }}-input"
                           {% if item.value == "True" %}checked{% endif %}
                        {% if item.scope == 1 %} disabled{% endif %}
                    >
                    {#                  <label class="form-check-label"></label>#}
                  </div>

                </div>
              {% endif %}
            </div>
          </div>
        {% endfor %}
      </div>
    </div>
  </div>
</div>